﻿Imports System.Runtime.InteropServices

Module Spcidev

    <DllImport("spcidev.dll", EntryPoint:="OpenDevice", CallingConvention:=CallingConvention.Cdecl)>
    Public Function OpenDevice(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="CloseDevice", CallingConvention:=CallingConvention.Cdecl)>
    Public Function CloseDevice(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDeviceModel", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDeviceModel(ByVal DevIndex As Integer, ByRef Model As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDeviceSN", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDeviceSN(ByVal DevIndex As Integer, ByRef SN As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ReadDevice", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ReadDevice(ByVal DevIndex As Integer, ByVal OffsetAddress As UInteger, ByRef Value As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="WriteDevice", CallingConvention:=CallingConvention.Cdecl)>
    Public Function WriteDevice(ByVal DevIndex As Integer, ByVal OffsetAddress As UInteger, ByVal Value As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDriverFifoUsedw", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDriverFifoUsedw(ByVal DevIndex As Integer, ByRef DriverFifoUsedw As UInteger) As Integer
    End Function

    '--------------------------------------------------------------------------
    'analog input function

    <DllImport("spcidev.dll", EntryPoint:="AiReady", CallingConvention:=CallingConvention.Cdecl)>
    Public Function AiReady(ByVal DevIndex As Integer, ByVal ReadyOrNot As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiConnectType", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiConnectType(ByVal DevIndex As Integer, ByVal AiConnectType As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiChannelSellect", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiChannelSellect(ByVal DevIndex As Integer, ByVal AiChannelSellect As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiSampleMode", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiSampleMode(ByVal DevIndex As Integer, ByVal AiSampleMode As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiRange", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiRange(ByVal DevIndex As Integer, ByVal AiRange As UInteger, ByVal AiChannel As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiSamplePeriod", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiSamplePeriod(ByVal DevIndex As Integer, ByVal AiSamplePeriod As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiOneShotCount", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiOneShotCount(ByVal DevIndex As Integer, ByVal AiOneShotCount As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAiTrigSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiTrigSource(ByVal DevIndex As Integer, ByVal AiTrigSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetAiOnePoint", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetAiOnePoint(ByVal DevIndex As Integer, ByVal AiChannel As UInteger, ByRef AiValue As Single) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetAiData", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetAiData(ByVal DevIndex As Integer, ByVal Points As UInteger, ByRef AiValue As Single, ByRef AiFifoUsdw As UInteger, ByVal Timeout As Integer) As Integer
    End Function

    '--------------------------------------------------------------------------
    'analog output function

    <DllImport("spcidev.dll", EntryPoint:="AoReady", CallingConvention:=CallingConvention.Cdecl)>
    Public Function AoReady(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal ReadyOrNot As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoMode", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoMode(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoMode As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoSamplePeriod", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoSamplePeriod(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoSamplePeriod As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoNCycleCount", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoNCycleCount(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoNCycleCount As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoTrigSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoTrigSource(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoTrigSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoValue(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoValue As Single) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoPowerOnValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoPowerOnValue(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoPowerOnValue As Single) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoFifo", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoFifo(ByVal DevIndex As Integer, ByVal AoChannel As UInteger, ByVal AoWaveData As Single) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearAoFifo", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearAoFifo(ByVal DevIndex As Integer, ByVal AoChannel As UInteger) As Integer
    End Function

    '--------------------------------------------------------------------------
    'digital input function

    <DllImport("spcidev.dll", EntryPoint:="DiReady", CallingConvention:=CallingConvention.Cdecl)>
    Public Function DiReady(ByVal DevIndex As Integer, ByVal ReadyOrNot As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiSampleMode", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiSampleMode(ByVal DevIndex As Integer, ByVal DiSampleMode As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiSamplePeriod", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiSamplePeriod(ByVal DevIndex As Integer, ByVal DiSamplePeriod As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiOneShotCount", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiOneShotCount(ByVal DevIndex As Integer, ByVal DiOneShotCount As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiTrigSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiTrigSource(ByVal DevIndex As Integer, ByVal DiTrigSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDiStatus", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDiStatus(ByVal DevIndex As Integer, ByVal Part As UInteger, ByRef DiValue As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDiData", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDiData(ByVal DevIndex As Integer, ByVal Points As UInteger, ByRef DiValue As UInteger, ByRef DiFifoUsdw As UInteger, ByVal Timeout As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiIntLevel", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiIntLevel(ByVal DevIndex As Integer, ByVal DiIntLevel As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiIntSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiIntSource(ByVal DevIndex As Integer, ByVal DiIntSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiIntEn", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiIntEn(ByVal DevIndex As Integer, ByVal DiIntEn As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiSensitivity", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiSensitivity(ByVal DevIndex As Integer, ByVal DiSensitivity As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiCountEn", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiCountEn(ByVal DevIndex As Integer, ByVal DiCountEn As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiCountEdge", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiCountEdge(ByVal DevIndex As Integer, ByVal DiCountEdge As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="GetDiCountValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function GetDiCountValue(ByVal DevIndex As Integer, ByVal DiChan As UInteger, ByRef DiCountValue As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearDiCountValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearDiCountValue(ByVal DevIndex As Integer, ByVal DiChan As UInteger) As Integer
    End Function

    '--------------------------------------------------------------------------
    'digital output function

    <DllImport("spcidev.dll", EntryPoint:="DiReady", CallingConvention:=CallingConvention.Cdecl)>
    Public Function DoReady(ByVal DevIndex As Integer, ByVal ReadyOrNot As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="DiReady", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoMode(ByVal DevIndex As Integer, ByVal DoMode As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoSamplePeriod", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoSamplePeriod(ByVal DevIndex As Integer, ByVal DoSamplePeriod As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoNCycleCount", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoNCycleCount(ByVal DevIndex As Integer, ByVal DoNCycleCount As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoTrigSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoTrigSource(ByVal DevIndex As Integer, ByVal DoTrigSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoValue(ByVal DevIndex As Integer, ByVal DoValue As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoPowerOnValue", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoPowerOnValue(ByVal DevIndex As Integer, ByVal DoPowerOnValue As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoFifo", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoFifo(ByVal DevIndex As Integer, ByVal DoWaveData As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearDoFifo", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearDoFifo(ByVal DevIndex As Integer) As Integer
    End Function

    '--------------------------------------------------------------------------
    'trig system function

    <DllImport("spcidev.dll", EntryPoint:="SetAiSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAiSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDiSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDiSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetAoSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetAoSoftTrig(ByVal DevIndex As Integer, ByVal AoChannel As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDoSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDoSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetExtTrigInEdge", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetExtTrigInEdge(ByVal DevIndex As Integer, ByVal TrigEdge As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearAiSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearAiSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearDiSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearDiSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearAoSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearAoSoftTrig(ByVal DevIndex As Integer, ByVal AoChannel As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearDoSoftTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearDoSoftTrig(ByVal DevIndex As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="ClearExtTrig", CallingConvention:=CallingConvention.Cdecl)>
    Public Function ClearExtTrig(ByVal DevIndex As Integer) As Integer
    End Function

    '--------------------------------------------------------------------------
    'sync function

    <DllImport("spcidev.dll", EntryPoint:="SetClockSource", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetClockSource(ByVal DevIndex As Integer, ByVal ClockSource As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetSyncClkDir", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetSyncClkDir(ByVal DevIndex As Integer, ByVal Direction As UInteger) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDioDir", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDioDir(ByVal DevIndex As Integer, ByVal DioDir As Integer) As Integer
    End Function

    <DllImport("spcidev.dll", EntryPoint:="SetDioDirDefault", CallingConvention:=CallingConvention.Cdecl)>
    Public Function SetDioDirDefault(ByVal DevIndex As Integer, ByVal DioDirDefault As UInteger) As Integer
    End Function

End Module
