﻿Module Module1

    ' 此例程对采集卡数字输出通道的状态进行单次设置。
    ' 此例程适用型号：
    ' PCI-1232
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx

    Sub Main()

        Dim rst As Integer
        Dim DevIndex As Integer = 0

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 方向
        ' 此处将所有的数字 I/O 通道设置为输出
        ' 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
        ' 此处全部设置为输入
        ' 其他数字 I/O 不支持设置的型号可以不用设置
        rst = SetDioDir(DevIndex, &H0)
        If (rst < 0) Then Return

        ' 设置 Do 住处状态
        ' 此处将所有的 Do 通道输出为高电平
        rst = SetDoValue(DevIndex, &HFFFFFFFF)
        If (rst < 0) Then Return

        Console.WriteLine("Success.")

        ' 关闭设备
        rst = CloseDevice(DevIndex)

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
