﻿Module Module1

    ' 此例程设置数字I/O通道上电时的默认方向和 Do 上电默认值。
    ' 此例程适用型号：
    ' PCI-1232
    ' PCI-1316
    ' PCI-225x
    ' PCI-3xxx
    ' PCI-5xxx

    Sub Main()
        Dim rst As Integer
        Dim DevIndex As Integer = 0

        ' 打开设备
        rst = OpenDevice(DevIndex)
        If (rst < 0) Then Return

        ' 设置数字 I/O 上电默认方向
        ' 参数每一 bit 对应一个 数字 I/O
        ' 此处全部设置为输出
        rst = SetDioDirDefault(DevIndex, &H0)
        If (rst < 0) Then Return

        ' 设置 Do 上电默认值
        ' 参数每一 bit 对应一个 Do
        ' 此处全部设置为 0
        rst = SetDoPowerOnValue(DevIndex, &H0)
        If (rst < 0) Then Return

        Console.WriteLine("Success.")

        ' 关闭设备
        rst = CloseDevice(DevIndex)
        If (rst < 0) Then Return

        Console.WriteLine("press any key to quit.")
        Console.ReadKey()

    End Sub

End Module
